﻿using System;
using System.Collections.Generic;
using System.Text;

namespace scgms_mobile.Misc
{
    /// <summary>
    /// Enumerator class of known BLE services and characteristics GUIDs
    /// </summary>
    class BLEKnownGuids
    {
        // SERVICE: device info service
        public static readonly Guid DeviceInfoServiceGUID = new Guid("0000180A-0000-1000-8000-00805F9B34FB");
        // ManufacturerString
        public static readonly Guid DeviceInfo_ManufacturerStringGUID = new Guid("00002A29-0000-1000-8000-00805F9B34FB");
        // ModelString
        public static readonly Guid DeviceInfo_ModelStringGUID = new Guid("00002A24-0000-1000-8000-00805F9B34FB");
        // SerialNumberString
        public static readonly Guid DeviceInfo_SerialNumberStringGUID = new Guid("00002A25-0000-1000-8000-00805F9B34FB");

        // SERVICE: battery
        public static readonly Guid BatteryServiceGUID = new Guid("0000180f-0000-1000-8000-00805f9b34fb");
        // BatteryCharge (R/N)
        public static readonly Guid BatteryChargeGUID = new Guid("00002a19-0000-1000-8000-00805f9b34fb");

        /** IEEE 11073 PHD-CGM Specification */

        // SERVICE: CGMS main
        public static readonly Guid IEEEMainServiceGUID = new Guid("0000181F-0000-1000-8000-00805F9B34FB");
        // CGM Measurement (R/N)
        public static readonly Guid IEEE_MeasurementGUID = new Guid("00002AA7-0000-1000-8000-00805F9B34FB");
        // CGM Feature (R)
        public static readonly Guid IEEE_FeatureGUID = new Guid("00002AA8-0000-1000-8000-00805F9B34FB");
        // CGM Status (R)
        public static readonly Guid IEEE_StatusGUID = new Guid("00002AA9-0000-1000-8000-00805F9B34FB");
        // Session start time (R/W)
        public static readonly Guid IEEE_SessionStartTimeGUID = new Guid("00002AAA-0000-1000-8000-00805F9B34FB");
        // Session run time (R)
        public static readonly Guid IEEE_SessionRunTimeGUID = new Guid("00002AAB-0000-1000-8000-00805F9B34FB");
        // Record access control point (W/I)
        public static readonly Guid IEEE_RecordAccessControlPointGUID = new Guid("00002A52-0000-1000-8000-00805F9B34FB");
        // CGM Specific ops control point (W/I)
        public static readonly Guid IEEE_CGMSpecificControlPointGUID = new Guid("00002AAC-0000-1000-8000-00805F9B34FB");

        /** Medtronic Guardian Connect */

        // SERVICE: CGMS main
        public static readonly Guid GuardianMainServiceGUID = new Guid("B0202E40-008B-11E3-A5F3-0002A5D5C51B");
        // CGM measurement ready (R/I)
        public static readonly Guid Guardian_MeasurementReady = new Guid("B541F660-008B-11E3-8A33-0002A5D5C51B");
        // CGM measurement data (R)
        public static readonly Guid Guardian_MeasurementData = new Guid("B85550E0-008B-11E3-AC4E-0002A5D5C51B");
        // CGM backfill ready (R,I)
        public static readonly Guid Guardian_BackfillReady = new Guid("BD771900-008B-11E3-B42A-0002A5D5C51B");
        // CGM backfill data (R)
        public static readonly Guid Guardian_BackfillData = new Guid("C139ED60-008B-11E3-A001-0002A5D5C51B");
        // CGM calibration response ready (R,I)
        public static readonly Guid Guardian_CalibrationResponseReady = new Guid("C52160C0-008B-11E3-9FE8-0002A5D5C51B");
        // CGM calibration response data (R)
        public static readonly Guid Guardian_CalibrationResponseData = new Guid("C8E5BBC0-008B-11E3-A1F7-0002A5D5C51B");
        // non-critical ops control point (W,I)
        public static readonly Guid Guardian_NonCriticalOpsControlPoint = new Guid("D8B8F120-008B-11E3-BDA3-0002A5D5C51B");
        // critical ops control point (W,I)
        public static readonly Guid Guardian_CriticalOpsControlPoint = new Guid("F53CBF20-008B-11E3-9A50-0002A5D5C51B");
        // start communication characteristics (R,I)
        public static readonly Guid Guardian_START_COMMS = new Guid("CFBA6400-008B-11E3-86E6-0002A5D5C51B");
        // sensor connected state (R,I)
        public static readonly Guid Guardian_SENSOR_CONNECTED_STATE = new Guid("B3F0DB00-C81D-11E3-9C1A-0800200C9A66");
        // sensor expiration (R,I)
        public static readonly Guid Guardian_SENSOR_EXPIRATION = new Guid("D3CB0A40-008B-11E3-8007-0002A5D5C51B");
        // sensor calibration expiration (R,I)
        public static readonly Guid Guardian_SENSOR_CAL_EXPIRATION = new Guid("05528AD7-D2D2-39E3-2976-E7FA42DBED19");

        // SERVICE: Sensor Info
        public static readonly Guid GuardianSensorInfoServiceGUID = new Guid("15DBCD61-6388-4C33-B9D8-580254FED03B");
        // ??? (I)
        public static readonly Guid Guardian_SensorInfo_IndicateInput = new Guid("C774EDAC-E573-45E1-97C6-8B5C18CC571A");
        // ??? (R)
        public static readonly Guid Guardian_SensorInfo_ReadInput = new Guid("DE3E5221-1308-439C-A13A-884DDC387CA7");
        // ??? (W)
        public static readonly Guid Guardian_SensorInfo_WriteOutput = new Guid("8484039E-97D3-40C0-BB55-C70C17BADAE2");
    }
}
