﻿using scgms_mobile.Misc;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Security.Cryptography;
using System.Text;

namespace scgms_mobile.Devices.Guardian.Packets
{
    class AuthChallengeResponse
    {
        public static byte[] Build(byte[] signKey, byte[] signBytes, byte[] sensorAdvIV)
        {
            using (HMACSHA256 hmac = new HMACSHA256(signKey))
            {
                byte[] merged = new byte[signBytes.Length + sensorAdvIV.Length];
                Array.Copy(signBytes, merged, signBytes.Length);
                Array.Copy(sensorAdvIV, 0, merged, signBytes.Length, sensorAdvIV.Length);

                Debug.WriteLine("Signing using key: " + Utils.ByteArrayToHexString(signKey));

                byte[] signature = hmac.ComputeHash(merged);

                byte[] outpacket = new byte[1 + signature.Length];
                outpacket[0] = (byte)Opcodes.AUTH_CHALLENGE_RESPONSE;
                Array.Copy(signature, 0, outpacket, 1, signature.Length);

                return outpacket;
            }
        }
    }
}
