﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace scgms_mobile.Devices.Guardian.Packets
{
    class CalibrationRequest
    {
        public static byte[] Build(double valueMmolL, uint timeOffset)
        {
            MemoryStream startBuf = new MemoryStream(1 + 2 + 4 + 1);
            using (BinaryWriter writer = new BinaryWriter(startBuf))
            {
                writer.Write((byte)Opcodes.CALIBRATION_REQUEST);
                writer.Write((ushort)(valueMmolL * 18.018));    // Medtronic device requires mg/dl
                writer.Write((uint)timeOffset);                 // current calibration time offset
                writer.Write((byte)0);                          // unk, always 0

                return startBuf.ToArray();
            }
        }
    }
}
